#define ITERACOES 1000000    // numero de iterações que serão realizadas
#define FLASH 100000            // iteração que o led começará a piscar a cada iteração

void setup() {
  //LED_BUILTIN é uma constante nativa que indica o pino que controla o LED interno
  pinMode(LED_BUILTIN, OUTPUT); //configura o pino que controla o LED interno como saida
  Serial.begin(9600);
}

void loop() {

  //variaveis que serão utilizadas para o calculo do tempo de execução
  unsigned long inicio, tempoTotal;
  unsigned long contador = ITERACOES;
  long int LEDcounter = 0; //contador de piscadas do LED
  boolean alternador = false; //controlador para alternar a ativação do LED
  
  digitalWrite(LED_BUILTIN, LOW); //desliga o LED

  long int i;
  
  inicio = millis();//guarda o tempo de inicio da execução do algoritmo
  
  //iterações
  for ( i = 0; i < contador; i++) {
    //verifica se o LED ja deve começar a piscar
    if (i+1 > FLASH) 
    {
      LEDcounter++;
      if (alternador) {
        digitalWrite(LED_BUILTIN, HIGH);
        alternador = false;
      } else {
        digitalWrite(LED_BUILTIN, LOW);
        alternador = true;
      }
    }
  }
   
  tempoTotal = millis() - inicio; //calcula o tempo gasto na execução do algortimo (resultado em ms)

  digitalWrite(LED_BUILTIN, LOW); //apaga o LED após a execução

  Serial.print("# numero de iterações = ");
  Serial.println(contador);
  Serial.print("Led piscou [ ");
  Serial.print(LEDcounter);
  Serial.println(" ] vezes");
  Serial.print("Tempo total: "); Serial.print(tempoTotal); Serial.println(" ms");
  Serial.println();Serial.println();

  delay(3000);
}

